searchNodes=[{"doc":"","ref":"K8sProbe.html","title":"K8sProbe","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"K8sProbe.html#child_spec/1","title":"K8sProbe.child_spec/1","type":"function"},{"doc":"Starts an instance of K8sProbe.Options:port - The default value is 9991.:probe_module - The default value is K8sProbe.Probe.","ref":"K8sProbe.html#start_link/1","title":"K8sProbe.start_link/1","type":"function"},{"doc":"A plug responsible for handling kubernetes liveness and readiness check probe requests.","ref":"K8sProbe.Endpoint.html","title":"K8sProbe.Endpoint","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"K8sProbe.Endpoint.html#call/2","title":"K8sProbe.Endpoint.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"K8sProbe.Endpoint.html#init/1","title":"K8sProbe.Endpoint.init/1","type":"function"},{"doc":"","ref":"K8sProbe.Probe.html","title":"K8sProbe.Probe","type":"behaviour"},{"doc":"","ref":"K8sProbe.Probe.html#liveness/0","title":"K8sProbe.Probe.liveness/0","type":"function"},{"doc":"","ref":"K8sProbe.Probe.html#c:liveness/0","title":"K8sProbe.Probe.liveness/0","type":"callback"},{"doc":"","ref":"K8sProbe.Probe.html#readiness/0","title":"K8sProbe.Probe.readiness/0","type":"function"},{"doc":"","ref":"K8sProbe.Probe.html#c:readiness/0","title":"K8sProbe.Probe.readiness/0","type":"callback"},{"doc":"K8sProbeProvides configurable HTTP liveness and readiness endpoints, intended to be used to support Kubernetes probes.K8sProbe ships with a built-in Cowboy HTTP server making this module easy to integrate into any project.","ref":"readme.html","title":"K8sProbe","type":"extras"},{"doc":"InstallationFirst, add :k8s_probe to your mix.exs dependencies like so:defp deps do [ # … your other various dependencies {:k8s_probe, &quot;0.3.0&quot;} ] endIf necessary run mix deps.get and mix deps.compile at this point to fetch and compile K8sProbe.Next, add K8sProbe to your supervision tree (perhaps in your application.ex file). It would look something like this:defmodule MyApp.Application do use Application def start(_type, _args) do children = [ K8sProbe ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end endNow you can try it out by launching your application and making a request to the probe endpoints as follows:# Start your app in iex $ iex -S mix # In another terminal $ curl localhost:9991/readiness OK $ curl localhost:9991/liveness OKCongratulations, you have a default probe up and running!Customising the probeThis module ships with a completely minimal default probe that does nothing other than respond with a 200 OK, regardless of the state of your application.This might be fine for simple applications, but for a more detailed implementation you need to provide your own probe implementing the K8sProbe.Probe behaviour. Here's an example:defmodule MyApp.MyProbe do @behaviour K8sProbe.Probe def readiness, do: :ok def liveness, do: :ok endEach of the probe functions must return either :ok or :error. How you implement your probe really depends on your application.Having written your probe, you can configure K8sProbe to use it by passing it in the configuration. Here's what your application.ex file might look like:defmodule MyApp.Application do use Application def start(_type, _args) do children = [ {K8sProbe, probe_module: MyApp.MyProbe} ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end end","ref":"readme.html#usage","title":"K8sProbe - Usage","type":"extras"},{"doc":"Generally it's recommended to just use the default configuration; easier isn't it! But if you must then read on...PortBy default K8sProbe listens on port 9991. You may override it by passing it as config option.","ref":"readme.html#configuration","title":"K8sProbe - Configuration","type":"extras"},{"doc":"Here's an example Kubernetes deployment in YAML format that calls the probes as implemented by default:--- apiVersion: apps/v1 kind: Deployment metadata: name: my-service spec: replicas: 1 selector: matchLabels: app.kubernetes.io/name: my-service template: spec: containers: name: my-service image: my-service ports: - containerPort: 9991 name: liveness-port protocol: TCP readinessProbe: httpGet: path: /readiness port: liveness-port livenessProbe: httpGet: path: /liveness port: liveness-port startupProbe: httpGet: path: /readiness port: liveness-portYou'll need to modify this configuration before it will work of course, replacing the image with your own.Configuring Kubernetes to make use of the probes provided by this module is a topic unto itself. See here for more information.","ref":"readme.html#configuring-probes-in-kubernetes","title":"K8sProbe - Configuring probes in Kubernetes","type":"extras"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"ChangedMinor simplification of code.","ref":"changelog.html#0-3-1","title":"Changelog - 0.3.1","type":"extras"},{"doc":"AddedBetter documentationRemovedDedicated health route is removed - use /liveness instead","ref":"changelog.html#0-2-0","title":"Changelog - 0.2.0","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras"},{"doc":"Copyright 2020 Joe Pearson Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]